/**************************************************************************************
 Copyright (c) 2002 The UbixOS Project
 All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions, the following disclaimer and the list of authors.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions, the following disclaimer and the list of authors
in the documentation and/or other materials provided with the distribution. Neither the name of the UbixOS Project nor the names of its
contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id: display.c,v 1.4 2002/10/07 00:04:33 reddawg Exp $

**************************************************************************************/

#include <drivers/display.h>
#include <ubixos/io.h>

unsigned char *displayBuffer = (unsigned char *)0xB8000;
int printColor = defaultColor;
unsigned int displayOffset = 0x0;

/************************************************************************

Function: void clearScreen();
Description: This Function Clears The Screen
Notes:

************************************************************************/
void clearScreen() {
  unsigned int i = 0x0;
  //Fill The Screen With Our Background Colod
  for (i=0x0;i<(defaultWidth*defaultHeight);i++) {
    displayBuffer[i*2] = 0x0;
    displayBuffer[i*2+1] = defaultColor;
    }
  //Store The Cursor Position
  displayOffset = 0x0;
  outportByte(0x3d4, 0x0f);                /* Set the cursor to the        */
  outportByte(0x3d5, 0);                   /* upper-left corner of the     */
  outportWord(0x3d4, 0x0e);                /* screen                       */
  outportByte(0x3d5, 0);
  //Return
  return;
  }

/************************************************************************

Function: void putString(char *);
Description: This Function Puts A String Of Chars On The Screen
Notes:

************************************************************************/  
void putStringOld(char *string) {
  unsigned int character = 0x0,i = 0x0;
  while ((character=*string++)) {
    switch(character) {
      case '\n':
        displayOffset = (((displayOffset/160)*160)+160);
        break;
      default:
        displayBuffer[displayOffset++] = character;
        displayBuffer[displayOffset++] = printColor;
        break;
      }
    //Check To See If We Are Out Of Bounds
    if (displayOffset >= 160*25) {
      for (i = 0; i < 160*24; i++) {
        displayBuffer[i] = displayBuffer[i+160];
        }
      for (i = 0; i < 80; i++) {
        displayBuffer[(160*24)+(i*2)] = 0x20;
        displayBuffer[(160*24)+(i*2)+1] = printColor;
        }
      displayOffset -= 160;
      }
    }
  return;
  }


void putString(char *string) {
  unsigned int bufferOffset = 0,character = 0,i = 0;
  /* We Need To Get The Y Position */
  outportByte(0x3d4, 0x0e);
  bufferOffset = inportByte(0x3d5);
  bufferOffset <<= 8; /* Shift Address Left 8 Bits */
  /* Then We Need To Add The X Position */
  outportByte(0x3d4, 0x0f);
  bufferOffset += inportByte(0x3d5);
  bufferOffset <<= 1; /* Shift Address Left 1 Bits */
  while ((character=*string++)) {
    switch(character) {
      case '\n':
        bufferOffset = (bufferOffset/160)*160 + 160;
        break;
      default:
        displayBuffer[bufferOffset++] = character;
        displayBuffer[bufferOffset++] = printColor;
        break;
      }
    /* Check To See If We Are Out Of Bounds */
    if (bufferOffset >= 160*25) {
      for (i = 0; i < 160*24; i++) {
        displayBuffer[i] = displayBuffer[i+160];
        }
      for (i = 0; i < 80; i++) {
        displayBuffer[(160*24)+(i*2)] = 0x20;
        displayBuffer[(160*24)+(i*2)+1] = printColor;
        }
      bufferOffset -= 160;
      }
    }
  bufferOffset >>= 1;                     /* Set the new cursor position  */
  outportByte(0x3d4, 0x0f);
  outportByte(0x3d5, bufferOffset & 0x0ff);
  outportWord(0x3d4, 0x0e);
  outportByte(0x3d5, bufferOffset >> 8);
  }